(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(window, function() {
return (window["webpackJsonp"] = window["webpackJsonp"] || []).push([["onms-interfaces-config"],{

/***/ "./src/main/assets/js/apps/onms-interfaces/onms-interfaces-config/index.js":
/*!*********************************************************************************!*\
  !*** ./src/main/assets/js/apps/onms-interfaces/onms-interfaces-config/index.js ***!
  \*********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
* @author Alejandro Galue <agalue@opennms.org>
* @copyright 2016 The OpenNMS Group, Inc.
*/


__webpack_require__(/*! core-js/modules/es.array.reverse */ "./node_modules/core-js/modules/es.array.reverse.js");

var _forEach = _interopRequireDefault(__webpack_require__(/*! ../../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/instance/for-each */ "./node_modules/@babel/runtime-corejs3/core-js-stable/instance/for-each.js"));

var _reverse = _interopRequireDefault(__webpack_require__(/*! ../../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/instance/reverse */ "./node_modules/@babel/runtime-corejs3/core-js-stable/instance/reverse.js"));

var _slice = _interopRequireDefault(__webpack_require__(/*! ../../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/instance/slice */ "./node_modules/@babel/runtime-corejs3/core-js-stable/instance/slice.js"));

var _parseInt2 = _interopRequireDefault(__webpack_require__(/*! ../../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/parse-int */ "./node_modules/@babel/runtime-corejs3/core-js-stable/parse-int.js"));

var _filter = _interopRequireDefault(__webpack_require__(/*! ../../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/instance/filter */ "./node_modules/@babel/runtime-corejs3/core-js-stable/instance/filter.js"));

var _context;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var angular = __webpack_require__(/*! ../../../vendor/angular-js */ "./src/main/assets/js/vendor/angular-js.js");

__webpack_require__(/*! ../../../lib/onms-http */ "./src/main/assets/js/lib/onms-http/index.js");

var configTemplate = __webpack_require__(/*! ../templates/template.config.html */ "./src/main/assets/js/apps/onms-interfaces/templates/template.config.html");

var sortTemplate = __webpack_require__(/*! ../templates/template.sort.html */ "./src/main/assets/js/apps/onms-interfaces/templates/template.sort.html");

(0, _filter.default)(_context = angular.module('onms-interfaces-config', ['onms.http', 'ui.bootstrap', 'angular-growl']).config(['growlProvider', function (growlProvider) {
  growlProvider.globalTimeToLive(5000);
  growlProvider.globalPosition('bottom-center');
}])).call(_context, 'startFrom', function () {
  return function (input, start) {
    var s = (0, _parseInt2.default)(start, 10);

    if (input) {
      return input.length < s ? input : (0, _slice.default)(input).call(input, s);
    }

    return [];
  };
}).directive('onmsInterfacesConfig', function () {
  return {
    restrict: 'E',
    scope: {
      nodeId: '=node'
    },
    templateUrl: configTemplate,
    controller: 'NodeInterfacesConfigCtrl'
  };
}).directive('sort', function () {
  return {
    restrict: 'A',
    transclude: true,
    templateUrl: sortTemplate,
    scope: {
      order: '=',
      by: '=',
      reverse: '='
    },
    link: function link(scope, element, attrs) {
      scope.onClick = function () {
        if (scope.order === scope.by) {
          scope.reverse = !(0, _reverse.default)(scope);
        } else {
          scope.by = scope.order;
          scope.reverse = false;
        }
      };
    }
  };
}).controller('NodeInterfacesConfigCtrl', ['$scope', '$http', '$filter', 'growl', function ($scope, $http, $filter, growl) {
  $scope.filters = {
    snmpInterface: null
  };
  $scope.snmpInterfaces = [];
  $scope.filteredSnmpInterfaces = [];
  $scope.snmpInterfacesPageSize = 10;
  $scope.snmpInterfacesMaxSize = 5;
  $scope.snmpInterfacesTotalItems = 0;
  $scope.snmpOrder = 'ifIndex';
  $scope.snmpReverse = false;

  $scope.loadSnmpInterfaces = function () {
    $http({
      url: 'rest/nodes/' + $scope.nodeId + '/snmpinterfaces',
      method: 'GET',
      params: {
        limit: 0
      }
    }).success(function (data) {
      $scope.snmpInterfaces = data.snmpInterface;
      $scope.setStylesForSnmpInterfaces();
      $scope.filteredSnmpInterfaces = $scope.snmpInterfaces;
      $scope.updateFilteredSnmpInterfaces();
    });
  };

  $scope.isCollectionEnabled = function (intf) {
    return intf.collectFlag === 'C' || intf.collectFlag === 'UC';
  };

  $scope.updateCollection = function ($event, intf) {
    $scope.enableCollection(intf, $event.target.checked);
  };

  $scope.enableCollection = function (intf, enable) {
    intf.collectFlag = enable ? 'UC' : 'UN';
    $http.put('rest/nodes/' + $scope.nodeId + '/snmpinterfaces/' + intf.ifIndex, 'collect=' + intf.collectFlag, {
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded'
      }
    }).success(function (data) {
      var action = $scope.isCollectionEnabled(intf) ? 'enabled' : 'disabled';
      growl.success('Data collection flag was successfully ' + action + ' for interface ' + intf.ifName);
    }).error(function (error, status) {
      growl.error('Cannot set data collection flag for interface ' + intf.ifName);
    });
  };

  $scope.updateFilteredSnmpInterfaces = function () {
    $scope.snmpInterfacesCurrentPage = 1;
    $scope.snmpInterfacesTotalItems = $scope.filteredSnmpInterfaces.length;
    $scope.snmpInterfacesNumPages = Math.ceil($scope.snmpInterfacesTotalItems / $scope.snmpInterfacesPageSize);
  };

  $scope.setStylesForSnmpInterfaces = function () {
    (0, _forEach.default)(angular).call(angular, $scope.snmpInterfaces, function (intf) {
      var cssClass = undefined;

      if (intf.ifAdminStatus !== 1) {
        cssClass = 'onms-interface-status-unknown';
      } else {
        if (intf.ifOperStatus === 1) {
          cssClass = 'onms-interface-status-up';
        } else {
          cssClass = 'onms-interface-status-down';
        }
      }

      intf.backgroundClass = cssClass;
    });
  };

  $scope.$watch('filters.snmpInterface', function () {
    $scope.filteredSnmpInterfaces = $filter('filter')($scope.snmpInterfaces, $scope.filters.snmpInterface);
    $scope.updateFilteredSnmpInterfaces();
  });
  $scope.loadSnmpInterfaces();
}]); // Bootstrap to a an element with ID 'onms-interfaces-config'

angular.element(document).ready(function () {
  var el = document.getElementById('onms-interfaces-config');
  angular.bootstrap(angular.element(el), ['onms-interfaces-config']);
});

/***/ }),

/***/ "./src/main/assets/js/apps/onms-interfaces/templates/template.config.html":
/*!********************************************************************************!*\
  !*** ./src/main/assets/js/apps/onms-interfaces/templates/template.config.html ***!
  \********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

var path = '/home/bamboo/opennms-release/opennms-source/core/web-assets/src/main/assets/js/apps/onms-interfaces/templates/template.config.html';
var html = "    <div class=\"jumbotron\" ng-show=\"snmpInterfaces.length == 0\">\n      <div class=\"container\">\n        <p>There are no SNMP interfaces for this node</p>\n      </div>\n    </div>\n    <div class=\"table-responsive\" ng-show=\"snmpInterfaces.length > 0\">\n      <div class=\"input-group\">\n        <input class=\"form-control\" type=\"text\" placeholder=\"Search/Filter SNMP Interfaces\" ng-model=\"filters.snmpInterface\">\n        <div class=\"input-group-append\">\n          <span class=\"input-group-text\"><i class=\"fa fa-search\"></i></span>\n        </div>\n      </div>\n      <table class=\"table table-sm\">\n        <thead>\n          <tr>\n            <th sort order=\"'ifIndex'\" by=\"snmpOrder\" reverse=\"snmpReverse\">SNMP ifIndex</th>\n            <th sort order=\"'ifType'\"  by=\"snmpOrder\" reverse=\"snmpReverse\">SNMP ifType</th>\n            <th sort order=\"'ifDescr'\" by=\"snmpOrder\" reverse=\"snmpReverse\">SNMP ifDescr</th>\n            <th sort order=\"'ifName'\"  by=\"snmpOrder\" reverse=\"snmpReverse\">SNMP ifName</th>\n            <th sort order=\"'ifAlias'\" by=\"snmpOrder\" reverse=\"snmpReverse\">SNMP ifAlias</th>\n            <th>Collect</th>\n          </tr>\n        </thead>\n        <tbody>\n          <tr ng-class=\"intf.backgroundClass\" ng-dblclick=\"openSnmpPage(intf)\" ng-repeat=\"intf in filteredSnmpInterfaces | orderBy:snmpOrder:snmpReverse | startFrom:(snmpInterfacesCurrentPage-1)*snmpInterfacesPageSize | limitTo:snmpInterfacesPageSize\">\n            <td>{{ intf.ifIndex }}</td>\n            <td>{{ intf.ifType  || 'N/A' }}</td>\n            <td>{{ intf.ifDescr || 'N/A' }}</td>\n            <td>{{ intf.ifName  || 'N/A' }}</td>\n            <td>{{ intf.ifAlias || 'N/A' }}</td>\n            <td>\n              <input type=\"checkbox\" ng-checked=\"isCollectionEnabled(intf)\" ng-click=\"updateCollection($event, intf)\" uib-tooltip=\"Check to enable collection, or uncheck to disable collection\"></input>\n            </td>\n          </tr>\n       </tbody>\n      </table>\n    </div>\n    <ul uib-pagination class=\"pagination-sm\"\n      total-items=\"snmpInterfacesTotalItems\"\n      num-pages=\"snmpInterfacesNumPages\"\n      ng-model=\"snmpInterfacesCurrentPage\"\n      max-size=\"snmpInterfacesMaxSize\"\n      boundary-links=\"true\"\n      ng-show=\"filteredSnmpInterfaces.length > snmpInterfacesPageSize\"></ul>\n";
window.angular.module('ng').run(['$templateCache', function(c) { c.put(path, html) }]);
module.exports = path;

/***/ }),

/***/ "./src/main/assets/js/apps/onms-interfaces/templates/template.sort.html":
/*!******************************************************************************!*\
  !*** ./src/main/assets/js/apps/onms-interfaces/templates/template.sort.html ***!
  \******************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

var path = '/home/bamboo/opennms-release/opennms-source/core/web-assets/src/main/assets/js/apps/onms-interfaces/templates/template.sort.html';
var html = "<span ng-click=\"onClick()\">\n  <span ng-transclude></span>&nbsp;&nbsp;\n  <i class=\"fa\" ng-class=\"{'fa-sort-alpha-asc': order===by && !reverse, 'fa-sort-alpha-desc': order===by && reverse}\"></i>\n</span>\n";
window.angular.module('ng').run(['$templateCache', function(c) { c.put(path, html) }]);
module.exports = path;

/***/ }),

/***/ "./src/main/assets/js/lib/onms-http/403-permission-denied.html":
/*!*********************************************************************!*\
  !*** ./src/main/assets/js/lib/onms-http/403-permission-denied.html ***!
  \*********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

var path = '/home/bamboo/opennms-release/opennms-source/core/web-assets/src/main/assets/js/lib/onms-http/403-permission-denied.html';
var html = "<div class=\"modal-header\">\n    <h3><i class=\"fa fa-exclamation-triangle text-warning\"></i> Permission Denied</h3>\n</div>\n<div class=\"modal-body\">\n    <h5>\n        You are not allowed to perform the requested action.\n    </h5>\n    <p class=\"text-muted\">\n        This is not supposed to happen.\n        Please reload the page and contact your administrator if this occurs more often.\n    </p>\n</div>\n<div class=\"modal-footer\">\n    <button class=\"btn btn-primary\" ng-click=\"reload()\">Reload</button>\n</div>";
window.angular.module('ng').run(['$templateCache', function(c) { c.put(path, html) }]);
module.exports = path;

/***/ }),

/***/ "./src/main/assets/js/lib/onms-http/index.js":
/*!***************************************************!*\
  !*** ./src/main/assets/js/lib/onms-http/index.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _startsWith = _interopRequireDefault(__webpack_require__(/*! ../../../../../../node_modules/@babel/runtime-corejs3/core-js-stable/instance/starts-with */ "./node_modules/@babel/runtime-corejs3/core-js-stable/instance/starts-with.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var angular = __webpack_require__(/*! ../../vendor/angular-js */ "./src/main/assets/js/vendor/angular-js.js");

var permissionDeniedTemplate = __webpack_require__(/*! ./403-permission-denied.html */ "./src/main/assets/js/lib/onms-http/403-permission-denied.html");

angular.module('onms.http', ['ui.bootstrap']).factory('InterceptorService', ['$q', '$rootScope', function ($q, $rootScope) {
  return {
    responseError: function responseError(rejection) {
      if (rejection.status === 401) {
        var _context, _context2;

        if (rejection.config && rejection.config.url && ((0, _startsWith.default)(_context = rejection.config.url).call(_context, 'rest/') || (0, _startsWith.default)(_context2 = rejection.config.url).call(_context2, 'api/v2/'))) {
          console.error('Login Required', rejection, rejection.headers); // eslint-disable-line no-console

          $rootScope.$emit('loginRequired');
        }
      }

      if (rejection.status === 403) {
        $rootScope.$emit('permissionDenied');
      }

      return $q.reject(rejection);
    }
  };
}]).config(['$httpProvider', function ($httpProvider) {
  $httpProvider.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest';
  $httpProvider.interceptors.push('InterceptorService');
}]).run(['$rootScope', '$uibModal', function ($rootScope, $uibModal) {
  $rootScope.$on('loginRequired', function () {
    var baseTags = document.getElementsByTagName('base');

    if (baseTags && baseTags.length > 0 && baseTags[0].href) {
      window.location.href = baseTags[0].href + 'login.jsp?session_expired=true';
    } else {
      console.warn('Login is required, but cannot forward to login page due to missing base tag.'); // eslint-disable-line no-console
    }
  });
  $rootScope.$on('permissionDenied', function () {
    $uibModal.open({
      templateUrl: permissionDeniedTemplate,
      controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
        $scope.reload = function () {
          $uibModalInstance.dismiss();
          window.location.reload();
        };
      }],
      size: '',
      backdrop: 'static',
      keyboard: false
    });
  });
}]);
module.exports = angular;

/***/ }),

/***/ "./src/main/assets/js/vendor/angular-js.js":
/*!*************************************************!*\
  !*** ./src/main/assets/js/vendor/angular-js.js ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/* Angular Core */
var angular = __webpack_require__(/*! ../../../../../node_modules/angular */ "./node_modules/angular/index.js-exposed");

__webpack_require__(/*! ../../../../../node_modules/angular-animate */ "./node_modules/angular-animate/index.js");

__webpack_require__(/*! ../../../../../node_modules/angular-cookies */ "./node_modules/angular-cookies/index.js");

__webpack_require__(/*! ../../../../../node_modules/angular-route */ "./node_modules/angular-route/index.js");

__webpack_require__(/*! ../../../../../node_modules/angular-resource */ "./node_modules/angular-resource/index.js");

__webpack_require__(/*! ../../../../../node_modules/angular-sanitize */ "./node_modules/angular-sanitize/index.js");
/* 3rd-Party Modules */


__webpack_require__(/*! ../../../../../node_modules/angular-growl-v2/build/angular-growl.min */ "./node_modules/angular-growl-v2/build/angular-growl.min.js");

__webpack_require__(/*! ../../../../../node_modules/angular-loading-bar */ "./node_modules/angular-loading-bar/index.js");

__webpack_require__(/*! ../../../../../node_modules/angular-growl-v2/build/angular-growl.css */ "./node_modules/angular-growl-v2/build/angular-growl.css");

__webpack_require__(/*! ../../../../../node_modules/angular-loading-bar/build/loading-bar.css */ "./node_modules/angular-loading-bar/build/loading-bar.css");
/* Bootstrap UI */


__webpack_require__(/*! ./bootstrap-js */ "./src/main/assets/js/vendor/bootstrap-js.js");

__webpack_require__(/*! ../../../../../node_modules/angular-bootstrap-checkbox/angular-bootstrap-checkbox */ "./node_modules/angular-bootstrap-checkbox/angular-bootstrap-checkbox.js");

__webpack_require__(/*! ../../../../../node_modules/ui-bootstrap4 */ "./node_modules/ui-bootstrap4/index.js"); // angular-ui-boostrap for bootstrap 4


console.log('init: angular-js'); // eslint-disable-line no-console

module.exports = window['angular'] = angular;

/***/ }),

/***/ "./src/main/assets/js/vendor/bootstrap-js.js":
/*!***************************************************!*\
  !*** ./src/main/assets/js/vendor/bootstrap-js.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


console.log('init: bootstrap-js'); // eslint-disable-line no-console

var jQuery = __webpack_require__(/*! ./jquery-js */ "./src/main/assets/js/vendor/jquery-js.js");

__webpack_require__(/*! ../../../../../node_modules/bootstrap/dist/js/bootstrap */ "./node_modules/bootstrap/dist/js/bootstrap.js");

module.exports = jQuery;

/***/ }),

/***/ "./src/main/assets/js/vendor/jquery-js.js":
/*!************************************************!*\
  !*** ./src/main/assets/js/vendor/jquery-js.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


console.log('init: jquery-js'); // eslint-disable-line no-console

var jQuery = __webpack_require__(/*! ../../../../../node_modules/jquery/dist/jquery */ "./node_modules/jquery/dist/jquery.js-exposed");

module.exports = jQuery;

/***/ })

},[["./src/main/assets/js/apps/onms-interfaces/onms-interfaces-config/index.js","vendor"]]]);
});
//# sourceMappingURL=onms-interfaces-config.js.map